from okahu_apptrace.instrumentation.metamodel.langchain import (
    _helper,
)
from okahu_apptrace.instrumentation.common.utils import get_vectorstore_deployment


RETRIEVAL = {
  "type": "retrieval",
  "attributes": [
    [
      {
        "_comment": "vector store name and type",
        "attribute": "name",
        "accessor": lambda arguments: type(arguments['instance'].vectorstore).__name__
      },
      {
        "attribute": "type",
        "accessor": lambda arguments: 'vectorstore.'+type(arguments['instance'].vectorstore).__name__
      },
      {
        "attribute": "deployment",
        "accessor": lambda arguments: get_vectorstore_deployment(arguments['instance'].vectorstore.__dict__)
      }
    ],
    [
      {
        "_comment": "embedding model name and type",
        "attribute": "name",
        "accessor": lambda arguments: getattr(arguments['instance'].vectorstore.embeddings, 'model', None) or getattr(arguments['instance'].vectorstore.embeddings, 'endpoint_name', None)
      },
      {
        "attribute": "type",
        "accessor": lambda arguments: 'model.embedding.' + (getattr(arguments['instance'].vectorstore.embeddings, 'model', None) or getattr(arguments['instance'].vectorstore.embeddings, 'endpoint_name', None))
      }
    ]
  ],
  "events": [
          {"name": "data.input",
           "attributes": [

               {
                   "_comment": "this is instruction and user query to LLM",
                   "attribute": "input",
                   "accessor": lambda arguments: _helper.update_input_span_events(arguments['args'])
               }
           ]
           },
          {
              "name": "data.output",
              "attributes": [
                  {
                      "_comment": "this is result from LLM",
                      "attribute": "response",
                      "accessor": lambda arguments: _helper.update_output_span_events(arguments['result'])
                  }
              ]
          }
      ]
}