from okahu_apptrace.instrumentation.common.utils import resolve_from_alias
from okahu_apptrace.instrumentation.metamodel.swarm import (
    _helper
)
INFERENCE = {
      "type": "agent",
      "attributes": [
        [
              {
                "_comment": "agent type",
                "attribute": "type",
                "accessor": lambda arguments:'agent.oai'
              },
              {
                "_comment": "name of the agent",
                "attribute": "name",
                "accessor": lambda arguments:arguments['kwargs']['agent'].name
              },
              {
                "_comment": "agent instructions. To be refactored",
                "attribute": "instructions",
                "accessor": lambda arguments: _helper.agent_instructions(arguments)
              },
              {
                "_comment": "agent tools",
                "attribute": "tools",
                "accessor": lambda arguments: [func.__name__ for func in arguments['kwargs']['agent'].functions]
              },
              {
                "_comment": "tool choice",
                "attribute": "tool_choice",
                "accessor": lambda arguments:arguments['kwargs']['agent'].tool_choice
              },
              {
                "attribute": "inference_endpoint",
                "accessor": lambda arguments: _helper.get_inference_endpoint(arguments)
              }
        ],
        [
              {
                "_comment": "LLM Model",
                "attribute": "name",
                "accessor": lambda arguments:arguments['kwargs']['agent'].model
              },
              {
                "attribute": "type",
                "accessor": lambda arguments: 'model.llm.'+arguments['kwargs']['agent'].model
              }
        ]
      ],
      "events": [
        {
          "name":"data.input",
          "attributes": [
            {
                "_comment": "this is LLM input",
                "attribute": "query",
                "accessor": lambda arguments: _helper.extract_input(arguments)
            }
          ]
        },
        {
          "name":"data.output",
          "attributes": [
            {
                "_comment": "this is response from LLM",
                "attribute": "response",
                "accessor": lambda arguments: _helper.handle_openai_response(arguments['result'])
            }
          ]
       },
       {
            "name": "metadata",
            "attributes": [
                {
                    "_comment": "this is metadata usage from LLM",
                    "accessor": lambda arguments: _helper.update_span_from_llm_response(arguments['result'])
                }
            ]
        }
      ]
    }